#!/usr/bin/perl
push (@INC, '/cgi-bin');

sub ReadParse {
    local (*in) = @_ if @_;

  local ($i, $loc, $key, $val);
  # Read in text
  if ($ENV{'REQUEST_METHOD'} eq "GET") {
    $in = $ENV{'QUERY_STRING'};
  } elsif ($ENV{'REQUEST_METHOD'} eq "POST") {
    read(STDIN,$in,$ENV{'CONTENT_LENGTH'});
  }

  @in = split(/&/,$in);

  foreach $i (0 .. $#in) {
    # Convert plus's to spaces
    $in[$i] =~ s/\+/ /g;

    # Split into key and value.
    ($key, $val) = split(/=/,$in[$i],2); # splits on the first =.

    # Convert %XX from hex numbers to alphanumeric
    $key =~ s/%(..)/pack("c",hex($1))/ge;
    $val =~ s/%(..)/pack("c",hex($1))/ge;
    $in_key[$i] = $key;
    $in_val[$i] = $val;
    # Associate key and value
    $in{$key} .= "\0" if (defined($in{$key})); # \0 is the multiple separator
    $in{$key} .= $val;
  }

  return 1; # just for fun
}


&ReadParse;
$domain=substr($ENV{'REMOTE_HOST'},-8);
$date = `date +%D`;
if ($in{'NAME'} eq '') { exit; }

print "Content-type: text/html\n\n";
if ($domain eq 'palm.net') {
	print "<Head><Title>Order Status</Title>";
	print '<meta name="palmcomputingplatform" content="true">';
	print '<meta name="historylisttext" content="';
	print "$in{'NAME'} &date &time";
	print '">';
}
else {
	print "<Head><Title>Stevens Creek Software Order Status</Title>";
}
print "</Head>";
print "<BODY BGCOLOR=\"#CCFFFF\">\n";

$date=`date '+%m/%d/%Y'`;
$date=substr($date,0,length($date)-1);
$time=`date '+%l:%M %p'`;
$time=substr($time,0,length($time)-1);
$mid=", ";
$date=$date.$mid.$time;
$acct=substr($in{'CARDNUM'},0,4);
print '<CENTER><A HREF="palmcall:SCsv.appl?Print" BUTTON>Print</A>';
print '<A HREF="palmcall:SCsv.appl?Memo" BUTTON>Save as Memo</A></CENTER>';
print '<FORM ACTION="default.cgi" METHOD="POST" ENCTYPE="application/x-www-form-urlencoded">';
print '<TEXTAREA NAME="Output" ROWS="11" COLS="32">';
print "*******************************************\r\r";
print "          Stevens Creek Software\r";
print "               Cupertino, CA\r";
print "                408-725-0424\r\r";
printf "DATE: %-20s\r",$date;
print "CUST: $in{'NAME'}\r";
printf "ACCT: %4sXXXXXXXXXXXX\r\r",$acct;
print "               ITEM                   PRICE\r";
print "----------------------------------   ------\r";

$total=0;
foreach $i (1 .. 6) {
  $val=USER.$i;
  $val2=PRICE.$i;
  if ($in{$val} ne '') {
    printf "%-35s%8.2f\r",$in{$val},$in{$val2};
    $total=$total+$in{$val2};
  }
}
if ($taxrate>0) {
         printf "%35s%8.2f\r","Tax:",$taxrate*$total;
   $total=$total+$taxrate*$total;
}
if ($in{'SHIP'}>0) {
   printf "%35s%8.2f\r","Shipping:",$in{'SHIP'};
   $total=$total+$in{'SHIP'};
}
printf "%35s%8.2f\r","TOTAL:",$total;
print "\r\r\rSign: _____________________________\r";
print "I agree to pay the amount shown above.\r";
print "\r";
print "*******************************************\r";
print "\r\r";
print "</TEXTAREA><BR>";
